=== debian/changelog ===
fltk1.1 (1.1.10-23) unstable; urgency=medium

  * debian/control:
    - Canonicalize with the help of cme fix.  In particular, declare
      Standards-Version: 3.9.8 (already compliant, not that cme checked).
    - Retire explicit libfltk1.1-dbg package in favor of automatic -dbgsym
      packages.
  * debian/libfltk1.1.symbols: GCC's stopped emitting one more destructor
    variant.
  * debian/rules:
    - Stop collecting debug symbols in an explicit libfltk1.1-dbg package.
    - Drop the fltk-config.unhardened business, which proved insufficient.
      (Do, however, postprocess fltk-config to avoid emitting the
      -fdebug-prefix-map=... flag intended to *improve* reproducibility!)
    - Configure --with-optim=... so fltk-config --optim won't claim -Os.
  * debian/.gitignore: Resync.
  * fltk-config.in: Filter out -D*, -f*, and -W*, not just -g* and -O* (but
    leave --optim output alone for reference).  (See #828081.)

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 24 Jan 2017 23:25:20 -0500

fltk1.1 (1.1.10-22) unstable; urgency=medium

  * debian/control: Drop explicit Multi-Arch: no setting, per
    https://lists.debian.org/debian-devel/2016/01/msg00688.html.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 14 Feb 2016 19:38:03 -0500

fltk1.1 (1.1.10-21) unstable; urgency=medium

  * debian/.gitignore: Ignore debhelper-build-stamp.
  * debian/control: Formally declare libfltk1.1-dev to be Multi-Arch: no,
    per hardcoded multiarch paths (to static libraries) in fltk-config.
  * debian/libfltk1.1.symbols: Mark one symbol newly elided by GCC 6 as
    optional.  (With the below, Closes: #811968.)
  * src/fl_draw.cxx: Move the min macro's definition down, to ensure no
    headers have the opportunity to undefine it.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 14 Feb 2016 17:47:33 -0500

fltk1.1 (1.1.10-20) unstable; urgency=medium

  * debian/control:
    - Drop build dependency on imagemagick.
    - Move libasound2-dev to Build-Depends-Arch.
    - Standards-Version: 3.9.6 (already compliant).
    - Modernize Vcs-* URLs.
  * debian/fltk1.1-games.install: Stop installing XPM icons.
  * debian/fltk1.1-games.menu: Retire in favor of .desktop files, per #741573.
  * debian/rules:
    - Stop generating XPM icons, needed only for the retired .menu entries.
    - Mark override_dh_{auto_install,makeshlibs,strip} as arch-only.
      (indep-only [-A] builds still need to build and run fluid for the sake
      of some installed examples).
    - Preserve fltk.spec across override_dh_auto_{clean,configure}.
  * debian/source/options: Rename back from local-options, per dgit.
  * debian/.gitignore: Unignore patches, per dgit.
  * documentation/Makefile: Postprocess fltk.{pdf,ps} to avoid dates or
    unreproducible IDs, following the general lead of
    https://wiki.debian.org/ReproducibleBuilds/TimestampsInPDFGeneratedByLaTeX
  * documentation/fluid.html: Tweak syntax so htmldoc won't fail.
  * fltk.spec: Reinstate, per dgit.
  * .gitignore: Stop ignoring fltk.spec.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 31 Dec 2015 21:25:29 -0500

fltk1.1 (1.1.10-19) unstable; urgency=medium

  * debian/fltk1.1.symbols: Mark previously mandatory symbols Clang 3.4
    doesn't emit as optional.
  * fluid/Fl_Type.h: Give ::make_type_browser a non-friend declaration
    because it has a default argument.  (Closes: #755228.)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 23 Jul 2014 23:39:38 -0400

fltk1.1 (1.1.10-18) unstable; urgency=medium

  * debian/fltk1.1.symbols: Mark the two previously mandatory symbols GCC
    4.8 doesn't emit as optional.  (Closes: #746848.)

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 13 May 2014 22:31:26 -0400

fltk1.1 (1.1.10-17) unstable; urgency=medium

  * debian/libfltk1.1.symbols:
    - Resolve most optional symbols by assuming GCC 4.6 or newer, already
      true as of wheezy.
    - Re-flag symbols absent when building with clang 3.3 as optional.
      (NB: Building with clang will still fail because it misoptimizes the
      fortified getcwd wrapper, causing fluid to enter an infinite loop.)
  * Standards-Version: 3.9.5 (already compliant).

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 20 Jan 2014 12:33:41 -0500

fltk1.1 (1.1.10-16) unstable; urgency=low

  * fltk-config.in: Fix --ldflags output to reinstate -lX11 (to account for
    potential calls to XCreatePixmap via the fl_create_offscreen macro) and to
    omit the explicit -L flag, as the script's automatic filtering of standard
    directories doesn't account for multiarch paths.  (See #713933 in fltk1.3.)

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 27 Jun 2013 21:55:14 -0400

fltk1.1 (1.1.10-15) unstable; urgency=low

  * debian/libfltk1.1.symbols: Flag symbols absent when built with Clang 3.2,
    and in one instance also with GCC 4.8, as optional.  (Closes: #701277.)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 06 Mar 2013 14:15:25 -0500

fltk1.1 (1.1.10-14) unstable; urgency=medium

  * debian/rules:
    - Keep hardening flags out of the installed fltk-config by adding an
      extra configure run with them disabled and using the resulting
      fltk-config.  (See #677705.)
    - Explicitly use hardened CPPFLAGS.
  * .gitignore: add fltk-config.unhardened.

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 18 Jun 2012 21:56:07 -0400

fltk1.1 (1.1.10-13) unstable; urgency=low

  * debian/control: drop ancient version on libfltk1.1-dev's libxft-dev
    suggestion.
  * debian/rules:
    - Pass hardened LDFLAGS to configure as DSOFLAGS too.  (Closes: #663278.)
    - Enable full hardening.
  * debian/source/options: rename to (git-only) local-options, so any
    source patches from NMUs will wind up in separate files.
  * src/Makefile: substitute -fPIC for -fPIE in C(XX)FLAGS.
  * test/Makefile: link the threads demo with LDFLAGS, not CXXFLAGS!
  * debian/po/pt_BR.po: update Brazilian Portuguese translation, thanks
    to J. S. Júnior.  (Closes: #663493.)

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 15 Mar 2012 22:41:00 -0400


