=== debian/watch ===
version=3
opts="downloadurlmangle=s|.*FILE=|ftp://ftp.easysw.com/pub/|,uversionmangle=s|rc|~rc|" \
http://www.fltk.org/software.php .*/fltk-(1\.1\.\d.*)-source\.tar\.gz
